SystemOrganization addCategory: #'XPath-GTExtensions'!
SystemOrganization addCategory: 'XPath-GTExtensions-Highlighting'!
SystemOrganization addCategory: 'XPath-GTExtensions-Highlighting-Parsers'!

!XMLDeclarationNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/6/2017 17:50'!
supportsXPathEvaluator
	^ false! !

!XMLDoctypeDeclaration methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/6/2017 17:50'!
supportsXPathEvaluator
	^ false! !

!XMLNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/26/2017 21:44'!
gtInspectorXPathIn: aComposite
	<gtInspectorPresentationOrder: 9>

	self supportsXPathEvaluator
		ifFalse: [^ self].

	aComposite custom:
		(GLMRubricHighlightedTextPresentation new
			title: 'XPath';
			editingMode: [
				GLMHighlighterTextRubEditingMode withStylerDecorator:
					GLMXPathHighlighterTextStylerDecorator new];
			display: [''];
			withLineNumbers: true;
			selectionAct: [:presentation |
				presentation
					selection:
						(self xpath: 
							(presentation selectedText asString
								ifEmpty: [presentation text asString]));
					clearUserEdits]
				on: $g
				entitled: 'Evaluate and go';
			act: [:presentation |
				presentation
					selection: (self xpath: presentation text asString);
					clearUserEdits]
				icon: GLMUIThemeExtraIcons glamorousGo
				on: $G
				entitled: 'Evaluate all and go').! !

!XMLNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/6/2017 17:51'!
supportsXPathEvaluator
	^ true! !

!XPathNamespaceNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/28/2017 05:35'!
supportsRemoveAction
	^ false! !

XMLHighlightDefaults subclass: #XPathExpressionHighlightDefaults
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-GTExtensions-Highlighting'!

XPathExpressionHighlightDefaults class
	instanceVariableNames: 'defaultAxisColor defaultNodeTestColor defaultPredicateColor defaultOperatorColor defaultFunctionCallColor defaultStringLiteralColor defaultNumberLiteralColor defaultVariableReferenceColor'!

!XPathExpressionHighlightDefaults commentStamp: 'monty 3/1/2017 15:10' prior: 0!
This class stores the default highlight TextColors used by the XPath expression highlighter. It gets the initial defaults from Shout text styling.!

XPathExpressionHighlightDefaults class
	instanceVariableNames: 'defaultAxisColor defaultNodeTestColor defaultPredicateColor defaultOperatorColor defaultFunctionCallColor defaultStringLiteralColor defaultNumberLiteralColor defaultVariableReferenceColor'!

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:37'!
defaultAxisColor
	^ defaultAxisColor
		ifNil: [defaultAxisColor := self textColorForShoutProperty: #self]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:31'!
defaultAxisColor: aTextColor
	defaultAxisColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 14:42'!
defaultFunctionCallColor
	^ defaultFunctionCallColor
		ifNil: [defaultFunctionCallColor := self textColorForShoutProperty: #keyword].! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:47'!
defaultFunctionCallColor: aTextColor
	defaultFunctionCallColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 14:08'!
defaultNodeTestColor
	^ defaultNodeTestColor
		ifNil: [defaultNodeTestColor := self textColorForShoutProperty: #instVar]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:36'!
defaultNodeTestColor: aTextColor
	defaultNodeTestColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:30'!
defaultNumberLiteralColor
	^ defaultNumberLiteralColor
		ifNil: [defaultNumberLiteralColor := self textColorForShoutProperty: #number]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:41'!
defaultNumberLiteralColor: aTextColor
	defaultNumberLiteralColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 14:45'!
defaultOperatorColor
	^ defaultOperatorColor
		ifNil: [defaultOperatorColor := self textColorForShoutProperty: #binary]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:38'!
defaultOperatorColor: aTextColor
	defaultOperatorColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 14:40'!
defaultPredicateColor
	^ defaultPredicateColor
		ifNil: [defaultPredicateColor := self textColorForShoutProperty: #blockStart]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:46'!
defaultPredicateColor: aTextColor
	defaultPredicateColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:28'!
defaultStringLiteralColor
	^ defaultStringLiteralColor
		ifNil: [defaultStringLiteralColor := self textColorForShoutProperty: #string]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:41'!
defaultStringLiteralColor: aTextColor
	defaultStringLiteralColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 14:44'!
defaultVariableReferenceColor
	^ defaultVariableReferenceColor
		ifNil: [defaultVariableReferenceColor := self textColorForShoutProperty: #globalVar]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:31'!
defaultVariableReferenceColor: aTextColor
	defaultVariableReferenceColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'class initialization' stamp: 'monty 3/1/2017 14:18'!
initialize
	"self initialize"

	defaultDefaultColor := nil.
	defaultAxisColor := nil.
	defaultNodeTestColor := nil.
	defaultPredicateColor := nil.
	defaultOperatorColor := nil.
	defaultFunctionCallColor := nil.
	defaultStringLiteralColor := nil.
	defaultNumberLiteralColor := nil.
	defaultVariableReferenceColor := nil.! !

XPathExpressionHighlightDefaults initialize!

XPathExpressionParser subclass: #XPathPositionExpressionParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-GTExtensions-Highlighting-Parsers'!

!XPathPositionExpressionParser commentStamp: 'monty 3/1/2017 15:13' prior: 0!
This class is an XPath expression parser that tracks the start and end positions of certain XPath constructs.!

!XPathPositionExpressionParser methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:37'!
currentPosition
	^ readStream position! !

!XPathPositionExpressionParser methodsFor: 'parsing' stamp: 'monty 3/1/2017 15:44'!
nextFunctionCall
	handler handleStartFunctionCallPosition: self currentPosition + 1.
	super nextFunctionCall.
	handler handleEndFunctionCallPosition: self currentPosition.! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 09:16'!
peekForAbbreviatedStep
	^ self
		peekWith: [super peekForAbbreviatedStep]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartAxisPosition: startPosition;
				handleEndAxisPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:30'!
peekForAdditiveOperator
	^ self
		peekWith: [super peekForAdditiveOperator]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartOperatorPosition: startPosition;
				handleEndOperatorPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:30'!
peekForAndOperator
	^ self
		peekWith: [super peekForAndOperator]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartOperatorPosition: startPosition;
				handleEndOperatorPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 14:27'!
peekForAxis
	^ self
		peekWith: [super peekForAxis]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartAxisPosition: startPosition;
				handleEndAxisPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:18'!
peekForEndPredicate
	super peekForEndPredicate
		ifTrue: [
			handler handleEndPredicatePosition: self currentPosition.
			^ true]
		ifFalse: [^ false]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:32'!
peekForEqualityOperator
	^ self
		peekWith: [super peekForEqualityOperator]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartOperatorPosition: startPosition;
				handleEndOperatorPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:30'!
peekForMultiplicativeOperator
	^ self
		peekWith: [super peekForMultiplicativeOperator]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartOperatorPosition: startPosition;
				handleEndOperatorPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:31'!
peekForNegationOperator
	^ self
		peekWith: [super peekForNegationOperator]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartOperatorPosition: startPosition;
				handleEndOperatorPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:43'!
peekForNodeTest
	^ self
		peekWith: [super peekForNodeTest]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartNodeTestPosition: startPosition;
				handleEndNodeTestPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 10:47'!
peekForNumberLiteral
	^ self
		peekWith: [super peekForNumberLiteral]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartNumberLiteralPosition: startPosition;
				handleEndNumberLiteralPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:30'!
peekForOrOperator
	^ self
		peekWith: [super peekForOrOperator]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartOperatorPosition: startPosition;
				handleEndOperatorPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:32'!
peekForRelationalOperator
	^ self
		peekWith: [super peekForRelationalOperator]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartOperatorPosition: startPosition;
				handleEndOperatorPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:18'!
peekForStartPredicate
	super peekForStartPredicate
		ifTrue: [
			handler handleStartPredicatePosition: self currentPosition.
			^ true]
		ifFalse: [^ false]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:29'!
peekForStringLiteral
	^ self
		peekWith: [super peekForStringLiteral]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartStringLiteralPosition: startPosition;
				handleEndStringLiteralPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:32'!
peekForUnionOperator
	^ self
		peekWith: [super peekForUnionOperator]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartOperatorPosition: startPosition;
				handleEndOperatorPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:28'!
peekForVariableReference
	^ self
		peekWith: [super peekForVariableReference]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartVariableReferencePosition: startPosition;
				handleEndVariableReferencePosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'private' stamp: 'monty 3/1/2017 14:30'!
peekWith: aFirstBlock startAndEndPositionsDo: aSecondBlock
	| oldPosition |

	oldPosition := self currentPosition.
	aFirstBlock value
		ifTrue: [
			aSecondBlock
				cull: oldPosition + 1
				cull: self currentPosition.
			^ true]
		ifFalse: [^ false].! !

XMLHighlighter subclass: #XPathExpressionHighlighter
	instanceVariableNames: 'axisColor nodeTestColor predicateColor operatorColor functionCallColor stringLiteralColor numberLiteralColor variableReferenceColor axisHighlight nodeTestHighlight predicateHighlightStack operatorHighlight functionCallHighlightStack stringLiteralHighlight numberLiteralHighlight variableReferenceHighlight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-GTExtensions-Highlighting'!

!XPathExpressionHighlighter commentStamp: 'monty 3/1/2017 15:11' prior: 0!
This class is highlighter to highlight XPath expression Text objects using XMLHighlights.!

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:01'!
axisColor
	^ axisColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:01'!
axisColor: aTextColor
	axisColor := aTextColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:27'!
defaults
	^ XPathExpressionHighlightDefaults! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:20'!
endAxisHighlightPosition: aPosition
	self
		endHighlight: axisHighlight
		position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:50'!
endFunctionCallHighlightPosition: aPosition
	self
		endHighlight: functionCallHighlightStack removeLast
		position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:20'!
endNodeTestHighlightPosition: aPosition
	self
		endHighlight: nodeTestHighlight
		position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:21'!
endNumberLiteralHighlightPosition: aPosition
	self
		endHighlight: numberLiteralHighlight
		position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:26'!
endOperatorHighlightPosition: aPosition
	self
		endHighlight: operatorHighlight
		position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:50'!
endPredicateHighlightPosition: aPosition
	self
		endHighlight: predicateHighlightStack removeLast
		position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:21'!
endStringLiteralHighlightPosition: aPosition
	self
		endHighlight: stringLiteralHighlight
		position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:29'!
endVariableReferenceHighlightPosition: aPosition
	self
		endHighlight: variableReferenceHighlight
		position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:03'!
functionCallColor
	^ functionCallColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:03'!
functionCallColor: aTextColor
	functionCallColor := aTextColor! !

!XPathExpressionHighlighter methodsFor: 'initialization' stamp: 'monty 3/1/2017 14:17'!
initializeColors
	super initializeColors.
	self
		axisColor: self defaults defaultAxisColor;
		nodeTestColor: self defaults defaultNodeTestColor;
		predicateColor: self defaults defaultPredicateColor;
		operatorColor: self defaults defaultOperatorColor;
		functionCallColor: self defaults defaultFunctionCallColor;
		stringLiteralColor: self defaults defaultStringLiteralColor;
		numberLiteralColor: self defaults defaultNumberLiteralColor;
		variableReferenceColor: self defaults defaultVariableReferenceColor.! !

!XPathExpressionHighlighter methodsFor: 'initialization' stamp: 'monty 3/1/2017 14:17'!
initializeHighlights
	super initializeHighlights.

	predicateHighlightStack := OrderedCollection new.
	functionCallHighlightStack := OrderedCollection new.! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:01'!
nodeTestColor
	^ nodeTestColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:02'!
nodeTestColor: aTextColor
	nodeTestColor := aTextColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:04'!
numberLiteralColor
	^ numberLiteralColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:04'!
numberLiteralColor: aTextColor
	numberLiteralColor := aTextColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:02'!
operatorColor
	^ operatorColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:02'!
operatorColor: aTextColor
	operatorColor := aTextColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:02'!
predicateColor
	^ predicateColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:02'!
predicateColor: aTextColor
	predicateColor := aTextColor! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:17'!
startAxisHighlightPosition: aPosition
	axisHighlight :=
		self
			newHighlightColor: self axisColor
			position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:13'!
startFunctionCallHighlightPosition: aPosition
	functionCallHighlightStack addLast:
		(self
			newHighlightColor: self functionCallColor
			position: aPosition)! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:17'!
startNodeTestHighlightPosition: aPosition
	nodeTestHighlight :=
		self
			newHighlightColor: self nodeTestColor
			position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:19'!
startNumberLiteralHighlightPosition: aPosition
	numberLiteralHighlight :=
		self
			newHighlightColor: self numberLiteralColor
			position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:18'!
startOperatorHighlightPosition: aPosition
	operatorHighlight :=
		self
			newHighlightColor: self operatorColor
			position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:13'!
startPredicateHighlightPosition: aPosition
	predicateHighlightStack addLast:
		(self
			newHighlightColor: self predicateColor
			position: aPosition)! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:18'!
startStringLiteralHighlightPosition: aPosition
	stringLiteralHighlight :=
		self
			newHighlightColor: self stringLiteralColor
			position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:19'!
startVariableReferenceHighlightPosition: aPosition
	variableReferenceHighlight :=
		self
			newHighlightColor: self variableReferenceColor
			position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:03'!
stringLiteralColor
	^ stringLiteralColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:03'!
stringLiteralColor: aTextColor
	stringLiteralColor := aTextColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:04'!
variableReferenceColor
	^ variableReferenceColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:04'!
variableReferenceColor: aTextColor
	variableReferenceColor := aTextColor! !

GLMXMLHighlighterTextStylerDecorator subclass: #GLMXPathHighlighterTextStylerDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-GTExtensions-Highlighting-Parsers'!

!GLMXPathHighlighterTextStylerDecorator methodsFor: 'private' stamp: 'monty 3/2/2017 06:21'!
highlightingParse: aString onSuccess: aOneArgumentBlock onError: aTwoArgumentBlock
	| highlightingParserHandler highlightingParser |

	highlightingParserHandler :=
		XPathHighlightingPositionExpressionParserHandler expressionSource:
			aString.
	highlightingParser :=
		XPathPositionExpressionParser
			on: aString
			for: highlightingParserHandler.
	[highlightingParser parse]
		on: XPathException
		do: [:error |
			^ aTwoArgumentBlock
				value: highlightingParserHandler
				value: highlightingParser currentPosition].
	^ aOneArgumentBlock value: highlightingParserHandler.! !

XPathExpressionParserHandler subclass: #XPathPositionExpressionParserHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-GTExtensions-Highlighting-Parsers'!

!XPathPositionExpressionParserHandler commentStamp: 'monty 3/1/2017 15:14' prior: 0!
This class is a handler for XPathPositionExpressionParsers.!

XPathPositionExpressionParserHandler subclass: #XPathHighlightingPositionExpressionParserHandler
	instanceVariableNames: 'highlighter expression expressionSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-GTExtensions-Highlighting-Parsers'!

!XPathHighlightingPositionExpressionParserHandler commentStamp: 'monty 3/1/2017 15:14' prior: 0!
This class is a highlighting handler for XPathPositionExpressionParsers that returns the parsed expression source as a highlighted Text object.!

!XPathHighlightingPositionExpressionParserHandler class methodsFor: 'instance creation' stamp: 'monty 3/1/2017 15:16'!
expressionSource: anExpression
	^ self new expressionSource: anExpression! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'converting' stamp: 'monty 3/1/2017 15:17'!
asHighlightedText
	| text |

	text := self expressionSource asText.
	highlighter highlightText: text.
	^ text.! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'converting' stamp: 'monty 3/2/2017 06:03'!
asHighlightedTextWithRemainderColored: aTextColor startingAt: aPosition
	| text |

	text := self asHighlightedText.
	highlighter
		highlightText: text
		withColor: aTextColor
		startingAt: aPosition.
	^ text.! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'accessing' stamp: 'monty 3/2/2017 06:29'!
encoding
	^ ''! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'accessing' stamp: 'monty 3/1/2017 15:16'!
expressionSource
	^ expressionSource ifNil: [expressionSource := '']! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'accessing' stamp: 'monty 3/1/2017 15:16'!
expressionSource: anExpressionSourceString
	expressionSource := anExpressionSourceString! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:24'!
handleEndAxisPosition: aPosition
	highlighter endAxisHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:24'!
handleEndFunctionCallPosition: aPosition
	highlighter endFunctionCallHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:24'!
handleEndNodeTestPosition: aPosition
	highlighter endNodeTestHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:25'!
handleEndNumberLiteralPosition: aPosition
	highlighter endNumberLiteralHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:26'!
handleEndOperatorPosition: aPosition
	highlighter endOperatorHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2017 14:49'!
handleEndParsing
	self parsingResult: self asHighlightedText! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:28'!
handleEndPredicatePosition: aPosition
	highlighter endPredicateHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:25'!
handleEndStringLiteralPosition: aPosition
	highlighter endStringLiteralHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:29'!
handleEndVariableReferencePosition: aPosition
	highlighter endVariableReferenceHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:24'!
handleStartAxisPosition: aPosition
	highlighter startAxisHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:24'!
handleStartFunctionCallPosition: aPosition
	highlighter startFunctionCallHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:24'!
handleStartNodeTestPosition: aPosition
	highlighter startNodeTestHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:25'!
handleStartNumberLiteralPosition: aPosition
	highlighter startNumberLiteralHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:26'!
handleStartOperatorPosition: aPosition
	highlighter startOperatorHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2017 10:23'!
handleStartParsing
	highlighter := XPathExpressionHighlighter new! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:29'!
handleStartPredicatePosition: aPosition
	highlighter startPredicateHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:25'!
handleStartStringLiteralPosition: aPosition
	highlighter startStringLiteralHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:29'!
handleStartVariableReferencePosition: aPosition
	highlighter startVariableReferenceHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'accessing' stamp: 'monty 3/1/2017 18:31'!
highlighter
	^ highlighter! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:18'!
handleEndAxisPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:18'!
handleEndFunctionCallPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:19'!
handleEndNodeTestPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:19'!
handleEndNumberLiteralPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:18'!
handleEndOperatorPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:19'!
handleEndPredicatePosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:20'!
handleEndStringLiteralPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:23'!
handleEndVariableReferencePosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:18'!
handleStartAxisPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:17'!
handleStartFunctionCallPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:19'!
handleStartNodeTestPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:19'!
handleStartNumberLiteralPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:18'!
handleStartOperatorPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:19'!
handleStartPredicatePosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:20'!
handleStartStringLiteralPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:23'!
handleStartVariableReferencePosition: aPosition! !

!XPath methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/8/2017 15:37'!
gtInspectorCompiledIn: aComposite
	<gtInspectorPresentationOrder: 8>

	aComposite pharoMethod
		title: 'Compiled';
		display: [
			[self compiledExpression block method]
				on: XPathException
				do: [:error |
					error class name asString, '
	"', error messageText, '"']];
		smalltalkClass: [
			[self compiledExpression block method methodClass]
				on: XPathException
				do: [:error | nil]]! !

!XPath methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/28/2017 03:03'!
gtInspectorSourceIn: aComposite
	<gtInspectorPresentationOrder: 7>

	aComposite custom:
		(GLMRubricHighlightedTextPresentation new
			title: 'Source';
			editingMode: [
				GLMHighlighterTextRubEditingMode withStylerDecorator:
					GLMXPathHighlighterTextStylerDecorator new];
			display: [self expressionSource];
			withLineNumbers: true;
			act: [:presentation |
				self expressionSource: presentation text asString.
				aComposite pane update]
				icon: GLMUIThemeExtraIcons glamorousAccept
				on: $s
				entitled: 'Accept';
			act: [:presentation |
				presentation update]
				icon: GLMUIThemeExtraIcons glamorousUndo
				entitled: 'Revert').! !

!XPath methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/8/2017 15:37'!
gtInspectorTestsIn: aComposite
	<gtInspectorPresentationOrder: 9>

	aComposite list
		title: 'Tests';
		display: [
			[self compiledExpression nodeTests]
				on: XPathException
				do: [:error | #()]]! !

XPathExpressionHighlightDefaults initialize!
